# -*- coding: utf-8 -*-

import hmac
import time
import base64
import urllib
import random
import struct
import hashlib
import urllib
import urllib2
import json

# Basic request URL
URL         = 'csec.api.qcloud.com/v2/index.php'
# 密钥,请进行替换,密钥申请地址 https://console.qcloud.com/capi
SECRET_ID   = ''
SECRET_KEY  = ''
REGION      = 'gz'

# Signature algorithm using HMAC-SHA1
def hmac_sha1(key, text):
    return base64.b64encode(hmac.new(key, text, hashlib.sha1).digest())

# Generates an available URL
def make_url(method, action, region, secret_id, secret_key, **args):
    # Fill common parameters and calculate and signature
    args['Nonce']     = random.randint(0, 0x7fffffff)
    args['Action']    = action
    args['Region']    = region
    args['SecretId']  = secret_id
    args['Timestamp'] = int(time.time())
    args['Signature'] = hmac_sha1(secret_key, '%s%s?%s' % (method, URL, '&'.join('%s=%s' % t for t in sorted(args.items()))))

    # Assemble final request URL
    return 'https://%s?%s' % (URL, '&'.join('%s=%s' % (k, urllib.quote(str(v))) for k, v in args.iteritems()))

# Message-Struct constructor for `UgcAntiSpam`
class Message(object):

    # Basic TLV structure
    class TLV(object):
        __type__ = 1000

        def __str__(self):
            return struct.pack('>II', self.__type__, len(self._value)) + self._value

        def __init__(self, value = ''):
            self._value = value

    # Message items of the Message-Struct
    class Content   (TLV):  __type__ = 1
    class ImageURL  (TLV):  __type__ = 2
    class VideoURL  (TLV):  __type__ = 3
    class AudioURL  (TLV):  __type__ = 4
    class WebsiteURL(TLV):  __type__ = 5
    class Emoticon  (TLV):  __type__ = 6
    class Title     (TLV):  __type__ = 7
    class Location  (TLV):  __type__ = 8
    class Custom    (TLV):  __type__ = 9
    class File      (TLV):  __type__ = 10
    class Other     (TLV):  __type__ = 1000

    # Assemble Messsage-Struct
    def __str__(self):
        return base64.b64encode(''.join(map(str, self._items)))

    def __init__(self, *items):
        for item in items:
            if not isinstance(item, Message.TLV):
                raise ValueError('Item is not a TLV')
        self._items = items

# demo section
def login_protection(**args):
    url     = make_url('GET', 'LoginProtection', REGION, SECRET_ID, SECRET_KEY, **args)
    data    = http_get(url)
    data    = json.loads(data.decode("UTF-8"))
    
    return data

def http_get(url):
    response = urllib2.urlopen(url=url)
    return response.read()

def http_post(url, **args):
    response = urllib2.urlopen(url=url, data=urllib.urlencode(args))
    return response.read()

__all__ = ['login_protection', 'make_url']

if __name__ == '__main__':
    data = login_protection(
        # 账号信息
        accountType          = '2',
        uid                  = 'D692D87319F2098C3877C3904B304706',
        associateAccount     = '373909726',
        nickName             = 'helloword',
        phoneNumber          = '086+15166666666',
        emailAddress         = 'hellword@qq.com',
        registerTime         = '1440416972',
        registerIp           = '121.14.96.121',
        passwordHash         = 'f158abb2a762f7919846ee9bf8445c7f22a244c5',

        # 行为信息
        loginIp              = '14.17.22.32',
        loginTime            = '124567895',
        loginSource          = '4',
        loginType            = '3',
        referer              = 'https://ui.ptlogin2.qq.com/cgi-bin/login',
        jumpUrl              = 'https://ui.ptlogin2.qq.com/cgi-bin/hello',
        cookieHash           = 'D692D87319F2098C3877C3904B304706',
        userAgent            = 'Mozilla/5.0 (Windows NT 5.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.132 Safari/537.36',
        xForwardedFor        = '121.14.96.121',
        mouseClickCount      = '10',
        keyboardClickCount   = '34',
        result               = '2',
        reason               = '4',

        # 设备信息
        macAddress           = '00-05-9A-3C-7A-00',
        vendorId             = 'tenecnt.com',
        imei                 = '54654654646',
        appVersion           = '10.0.1',

        # 其他信息
        businessId           = '1'
    )
    
    print json.dumps(data)
